#include "basics.h"
#include "c_types.h"

  collision_heap::collision_heap()
  {
    int j;
    for(j=0;j<c_heap_size;j++)
      a[j].b=0;
    a[0].time=0;
    heap_size=0;
  }

  void collision_heap::add_cn(c_notification cn)
  { int n;
    n=heap_size+1;
    if (n==c_heap_size) {orep << "collision heap overflow!!\n"; exit(0); }
    if (a[n/2].b || !heap_size) heap_size++;
    else while (!a[n/2].b) n=n/2;
    while(cn.time<a[n/2].time)
    {
      a[n]=a[n/2];
      n=n/2;
    }
    a[n]=cn;
  }
    
  void collision_heap::adjust_end()
  {
    while (!a[heap_size].b && heap_size)
      heap_size--;
  }

  void collision_heap::pullup(int n)
  {
    if (!a[n].b || n>heap_size)
        { }
    else if (!a[n*2].b && !a[n*2+1].b)
    {
      a[n].b=0;
    }
    else if (!a[n*2].b && a[n*2+1].b)
    {
      a[n]=a[n*2+1]; pullup(n*2+1);
    }
    else if (a[n*2].b && !a[n*2+1].b)
    {
      a[n]=a[n*2]; pullup(n*2);
    }
    else if (a[n*2].time<a[n*2+1].time)
    { 
      a[n]=a[n*2]; pullup(n*2);
    }
    else {
      a[n]=a[n*2+1]; pullup(n*2+1);
    }
    adjust_end();
  }

  void collision_heap::remove_unwanted(int n,Object *p)
  {
    if (a[n].b)
    {
      while ((a[n].p1==p || a[n].p2==p) && a[n].b)
        pullup(n);
      remove_unwanted(n*2,p);
      remove_unwanted(n*2+1,p);
    }
  }

  void collision_heap::update_checks(Object *x)
  {
    c_notification cn1;    
    net_unit *n;

    for(n=x->net_r;n;n=n->r)
    {
      if (!n->b && n->kp.checks>3)
      {
        cn1=check_collision(n); // hardly necessary if checks<4
        cn1.nu=n;
        if (cn1.b) add_cn(cn1);
      }
    }
    for(n=x->net_d;n;n=n->d)
    {
      if (!n->b && n->kp.checks>3)
      {
        cn1=check_collision(n);
        cn1.nu=n;
        if (cn1.b) add_cn(cn1);
      }
    }
  }

  void collision_heap::print_h(int j)
  {
    c_notification u;
  
    u=a[j];
    if (u.b)
    {
      print_h(j*2);
      print_h(j*2+1);
    }
  }

  void collision_heap::print_heap()
  {
    orep << "The heap looks thus:\n";
    print_h(1);
  }

