#include <cmath>
#include <cstdio>
#include "puz.h"
#include "kbt.h"
#include "xkinds3.h"
#include "draw2.h"

view_element::view_element(simple_view_element &s)
{ a=&s.a[0]; }

void view_element::draw_thing(DATAFILE *D,BITMAP* dest,int cx,int cy,pic_tree *pt)
{
  char buf[80];

  switch(a[0])
  {
// Level 0: Background

  case xk_Backg: enTree(dc_cleartocolour,0,pt,2,dest,a[1]); break;

// Level 1: Spikes, lever, ferris wheel

  case xk_Spikes:
    for (int j=0;j<a[3];j++)
      if (a[4])
        enTree(dc_spritev,3,pt,5,dest,D[u_Spike].dat,a[1]+12*j-(a[3]*6-1)+cx,a[2]+cy,1);
      else
        enTree(dc_sprite,3,pt,5,dest,D[u_Spike].dat,a[1]+12*j-(a[3]-1)*6+cx,a[2]+cy,1);
    break;

  case xk_Lever:
    enTree(dc_sprite,2,pt,5,dest,D[u_Lever1].dat,a[1]+cx,a[2]+cy,1);
    reg_line2(1,-a[3]-1,a[4],a[3]-1,-a[4],a[5]);
    reg_line2(1,-a[3]  ,a[4],a[3]  ,-a[4],a[5]);
    break;

  case xk_Ferris:
    enTree(dc_sprite,2,pt,5,dest,D[u_Lever1].dat,a[1]+cx,a[2]+cy,1);
    reg_line2(1,a[3]-1,a[4],-a[3]-1,-a[4],c3(000));
    reg_line2(1,a[3]  ,a[4],-a[3]  ,-a[4],c3(000));
    reg_line2(1,a[5]-1,a[6],-a[5]-1,-a[6],c3(000));
    reg_line2(1,a[5]  ,a[6],-a[5]  ,-a[6],c3(000));
    reg_line2(1,a[7]-1,a[8],-a[7]-1,-a[8],c3(000));
    reg_line2(1,a[7]  ,a[8],-a[7]  ,-a[8],c3(000));
    break;

// Level 2: All Set pieces (except platform), magnet, gong, control boxes

  case xk_Door:
  {
    draw_command d=dc_sprite;
    if (a[4]==3) d=dc_spriteh;
    if (a[4]==1) d=dc_spritev;
    enTree(d,2,pt,5,dest,D[u_Door1+a[3]+4*(a[4]<2)].dat,a[1]+cx,a[2]+cy,1);
  }
    break;

  case xk_Magnet:
    reg_sprite1(2,u_Mag1+a[3]); break;

  case xk_Gong:
    reg_sprite1(2,u_Gong); break;

  case xk_Setpiece:
  {
    int p=0;
    if (a[3]==1) p=u_Plat1;
    if (a[3]==2) p=u_Stone;
//    if (a[3]==3) p=u_Pole1;
    if (a[3]==4) p=u_Curve1;
    if (a[3]==5) p=u_Curve2;
    if (a[3]==6) p=u_Decor;
    reg_sprite1(2,p);

  } break;

  case xk_Door2:
    reg_sprite1(2,u_Trap1); break;

  case xk_Setp2:
    enTree(dc_rectfill,2,pt,6,dest,a[1]-a[3]+cx,a[2]-a[4]+cy,a[1]+a[3]-1+cx,a[2]+a[4]-1+cy,a[5]);
    break;

  case xk_Iceblock:
    enTree(dc_rectfill,2,pt,6,dest,a[1]-300+cx,a[2]-50+cy, a[1]+299+cx,a[2]+49+cy, c3(555));
    enTree(dc_rectfill,2,pt,6,dest,a[1]+100+cx,a[2]-150+cy,a[1]+299+cx,a[2]-51+cy, c3(555));
    enTree(dc_triangle,2,pt,8,dest,a[1]-99 +cx,a[2]-50+cy, a[1]+99+cx, a[2]-50+cy,a[1]+99+cx,a[2]-150+cy,c3(555));
    break;

  case xk_Seismos:
    enTree(dc_rectfill,2,pt,6,dest,a[1]+cx,    a[2]-400+cy,a[1]+9+cx,  a[2]-195+cy,c3(420));
    enTree(dc_rectfill,2,pt,6,dest,a[1]-610+cx,a[2]-400+cy,a[1]-601+cx,a[2]+49+cy, c3(420));
    enTree(dc_rectfill,2,pt,6,dest,a[1]-600+cx,a[2]+40+cy, a[1]-401+cx,a[2]+49+cy, c3(420));
    enTree(dc_rectfill,2,pt,6,dest,a[1]-402+cx,a[2]+cy,    a[1]-155+cx,a[2]+49+cy, c3(420));
    enTree(dc_triangle,2,pt,8,dest,a[1]-598+cx,a[2]+40+cy, a[1]-403+cx,a[2]+cy,a[1]-403+cx,a[2]+40+cy,c3(420));
    enTree(dc_circlefill,2,pt,5,dest,a[1]+cx,a[2]+cy,200,c3(420));
    enTree(dc_circlefill,2,pt,5,dest,a[1]+cx,a[2]+cy,160,c3(410));
    enTree(dc_circlefill,2,pt,5,dest,a[1]+cx,a[2]+cy,120,c3(310));
    break;

  case xk_Ctrlbox:
    reg_sprite1(2,u_Ctrl1-1+a[3]); break;

// Level 3: Home, back parts of teleport, platform

  case xk_Platform:
    reg_sprite1(3,u_Plat2); break;


  case xk_Teleport:
    enTree(dc_sprite,3,pt,5,dest,D[u_Telepic1].dat,a[1]+cx,a[2]+25+cy,1);
    enTree(dc_sprite,3,pt,5,dest,D[u_Telepic1].dat,a[1]+cx,a[2]-25+cy,1);

    for (int j=0;j<6;j++)
    {
      for(float y1=-20;y1<20;y1++)
      {
        float q=j*PI/3+a[4]*PI/48+0.1*sin(y1+0.5);
        float x2=15*sin(q);
        enTree(dc_plot,3+3*(cos(q)>0),pt,4,dest,fl2i(0.5+x2)+a[1]+cx,fl2i(y1)+a[2]+cy,a[3]);
//        orep << "j=" << j << ", y1=" << y1 << ", q=" << q << ", x2=" << x2 << ", X=" << fl2i(0.5+x2) << endl;
      }
    }
    break;

   case xk_Home: //enTree(dc_sprite,3,pt,5,dest,D[u_Home1+a[3]-1].dat,a[1]+cx,a[2]+cy,1);
     reg_sprite1(3,u_Home1+a[3]-1);
     break;

// Level 4-5: stars

  case xk_Star: //enTree(dc_sprite,4+a[3]/4,pt,5,dest,D[u_Star1000+(a[3]%4)*40+a[4]].dat,a[1]+cx,a[2]+cy,1); break;
    reg_sprite1(4+a[3]/4,u_Star1000+(a[3]%4)*40+a[4]); break;

// Level 6: Front of teleport, E-field, laser-beam

  case xk_Photon:
    reg_line1(6,a[1]-(a[1]>a[3]),a[2]-(a[2]>a[4]),a[3]-(a[3]>a[1]),a[4]-(a[4]>a[2]),c3(500));
    break;

  case xk_Zapper:
    if (a[5])
    {
      enTree(dc_sprite,6,pt,5,dest,D[u_Zap1].dat,a[1]+cx,a[2]-a[3]+cy,1);
      enTree(dc_spritev,6,pt,5,dest,D[u_Zap1].dat,a[1]+cx,a[2]+a[3]+cy,1);
    }
    else
    {
      enTree(dc_spriteh,6,pt,5,dest,D[u_Zap2].dat,a[1]-a[3]+cx,a[2]+cy,1);
      enTree(dc_sprite,6,pt,5,dest,D[u_Zap2].dat,a[1]+a[3]+cx,a[2]+cy,1);
    }

    if (a[4])
    {
      float a1=4;
      float b1=PI*(2*a[3]/10)/2/a[3];
      float w1=Time;

      for(int y1=0;y1<=2*a[3];y1++)
      {
        float x2=a1*sin(b1*y1)*sin(w1);

        if (a[5])
          enTree(dc_plot,3,pt,4,dest,fl2i(0.5+x2)+a[1]+cx,a[2]-a[3]+y1+cy,c3(254));
        else  
          enTree(dc_plot,3,pt,4,dest,a[1]-a[3]+y1+cx,fl2i(0.5+x2)+a[2]+cy,c3(254));
      }
    }
    break;

// Level 7: gettables chain

  case xk_Quay:
  case xk_Cutter:
  case xk_Bat:
  case xk_Trumpet:
  case xk_Mallet:
    {
      int p=0;
      if (a[0]==xk_Cutter)  p=u_Cutter;
      if (a[0]==xk_Bat)     p=u_Bat;
      if (a[0]==xk_Trumpet) p=u_Trumpet;
      if (a[0]==xk_Mallet)  p=u_Mallet;
      if (a[0]==xk_Quay)    p=u_Key1+a[4];

      if (a[3])
        if (cx==160)
        {
          enTree(dc_setclip,10,pt,5,dest,0,160,85,199);
          enTree(dc_sprite,10,pt,5,dest,D[p].dat,a[1]+43,a[2]+180,1);
          enTree(dc_setclip,10,pt,5,dest,0,0,319,199);
        }
        else
          enTree(dc_sprite,10,pt,5,dest,D[p].dat,a[1]+100,a[2]+460,1);
      else
        reg_sprite1(7,p);
    }
    break;

  case xk_Chain:
    for (int j=0;j<a[3];j+=6)
      enTree(dc_sprite,7,pt,5,dest,D[u_Chain].dat,a[1]+cx,a[2]+j+cy,1);
    break;

// Level 8: pushme heavy mirror laser

  case xk_Pushme:
    reg_sprite1(8,u_PushMe); break;

  case xk_Heavy:
    reg_sprite1(8,u_Heavy); break;

  case xk_Laser:
    reg_sprite1(8,u_Laser1+a[3]); break;

  case xk_Mirror:
    reg_sprite1(8,u_Mirror1a+a[3]*2+a[4]); break;

// Level 9: crosshairs arrow zed

  case xk_Zed:
    reg_sprite1(9,u_Zed1); break;

  case xk_Player:
    if (cx==320)
    {
      enTree(dc_sprite,13,pt,5,dest,D[u_Star1000+(a[3])*40+a[4]].dat,20,460,1);

      sprintf(buf,"Stars home:  %d",a[9]);  reg_text1(13,340,446,1);
      sprintf(buf,"Total stars: %d",a[8]);  reg_text1(13,170,446,1);
      sprintf(buf,"Stars dead:  %d",a[10]); reg_text1(13,340,466,1);
    }
    else
    {
      sprintf(buf,"Stars: %d",a[8]); reg_text1(13,2,131,216); reg_text1(14,1,131,1);
      sprintf(buf,"Home:  %d",a[9]); reg_text1(13,2,141,216); reg_text1(14,1,141,1);
      sprintf(buf,"Dead:  %d",a[10]);reg_text1(13,2,151,216); reg_text1(14,1,151,1);
    }

    if (!(a[5]&2))
      reg_sprite1(9,u_Bracket);
      
    if (!(a[5]/2))
      enTree(dc_sprite,13,pt,5,dest,D[u_CrosHair].dat,a[6]+cx,a[7]+cy,1);

    if (a[5]==3)
      enTree(dc_sprite,13,pt,5,dest,D[u_Arrow2].dat,a[1]-8+cx,a[2]+cy+5,1);

    if (a[5]==5)
      enTree(dc_sprite,13,pt,5,dest,D[u_Arrow2].dat,a[6]-8+cx,a[7]+cy+5,1);

    if (cx==320)
    {
      enTree(dc_sprite,11,pt,5,dest,D[u_StatusBar].dat,320,460,1);
      enTree(dc_sprite,9,pt,5,dest,D[u_Oval].dat,100,460,1);
    }
    else
    {
      enTree(dc_sprite,11,pt,5,dest,D[u_StatusBar1].dat,43,180,1);
      enTree(dc_sprite,9,pt,5,dest,D[u_Oval].dat,43,180,1);
    }
    break;
  }
}
