#include <fstream>
#include <allegro.h>
#include "basics.h"
#include "kbt.h"


 kbuf KeyBoard; // volatile?

volatile int Timer, Time, Frames, FramesCum[MaxTimerSpeed], FrameRate;
int TimerSpeed=0;


  kbuf::kbuf()
  { rd_pos=wr_pos=0; }

  void kbuf::enBuffer(char k)
  {
    int j;

    if ((wr_pos+1)%kbuf_size==rd_pos)
    {
      orep << "Ran out of room in the keyboard buffer:\n";
      for(j=0;j<kbuf_size;j++)
        if (j==wr_pos)
          orep << " XX";
        else orep << a[j];
      exit(0);
    }
    a[wr_pos]=k;
    wr_pos=(wr_pos+1)%kbuf_size;
  }

  char kbuf::deBuffer()
  {
    char r;
    if (wr_pos==rd_pos)
      return 0;
    else
    {
      r=a[rd_pos];
      rd_pos=(rd_pos+1)%kbuf_size;
      return r;     
    }
  }

  char kbuf::getkey()
  {
    char r;
    r=0;
    while (!r)
      r=deBuffer();
    return r;
  }


void onkeypres(int key)
{  
  if (key>=0 && key<128)
  {
    KeyBoard.enBuffer((char)key);
  }
}
END_OF_FUNCTION(onkeypres);

void TimerClick()
{
  Timer++;
  Time++;
  FrameRate=Frames-FramesCum[Time%TimerSpeed];
  FramesCum[Time%TimerSpeed]=Frames;
}
END_OF_FUNCTION(TimerClick);

void set_timer_speed(int s)
{
  TimerSpeed=s;
  if (!s && TimerSpeed)
    remove_int(TimerClick);

  if (s)
  {
    Timer=1; Frames=0;
    for (int j=0;j<s;j++)
    {
      FramesCum[j]=0;
    }
    install_int_ex(TimerClick, BPS_TO_TIMER(s));
  }
}

void initialise_kbt()
{ 
  Time=0;
  LOCK_VARIABLE(Time);
  LOCK_VARIABLE(Timer);
  LOCK_VARIABLE(Frames);
  LOCK_VARIABLE(FramesCum);
  LOCK_VARIABLE(FrameRate);
  LOCK_VARIABLE(KeyBoard);

  LOCK_FUNCTION(TimerClick);
  LOCK_FUNCTION(onkeypres);
 
}
