#ifndef _KBT_H_
#define _KBT_H_

/*
The artificial keyboard buffer class

enBuffer adds a char to the buffer
deBuffer gets a char off the buffer if there is one
getkey gets a char off the buffer and waits for one if there isn't

*/
#define kbuf_size 30
#define MaxTimerSpeed 500

class kbuf {
  volatile int wr_pos,rd_pos;
  volatile char a[kbuf_size];

public:
  kbuf();
  void enBuffer(char k);
  char deBuffer();
  char getkey();
};

extern kbuf KeyBoard; // volatile

// Timing stuff
extern volatile int Timer, /*Time,*/ Frames, FramesCum[MaxTimerSpeed], FrameRate;
extern int TimerSpeed;


void set_timer_speed(int s);

void initialise_kbt();

// Timer interrupt function
void TimerClick();


// The keyboard interrupt is redirected here
extern void onkeypres(int key);

#endif 
