#include <cstdio>
#include <iostream>
#include "puz.h"
#include "str.h"
#include "palettes.h"
#include "high.h"
#include "go.h"
#include "menu.h"
#include "kbt.h"
#include "define.h"

using namespace std;

FONT *smallfont = font;

/*

This is the main routine for the Puzzle Stars game and puzzle editor
Editor is now unavailable, because of unstability
*/


void ReScr();

void init_message()
{
	cout<< "--=[ Puzzle Stars " << "v.:" << VERSION << " - Eric & Kota543 ]=--" <<endl;
	cout<< " Trevor Tao - idea" << endl;
	cout<< " Eric Love - main code" << endl;
	cout<< " Juraj Michalek - Linux fixes and updates" <<endl;
	cout<< endl <<" -h for commandline help"<<endl; 
}

void help_message()
{
	cout<< "--=[ Puzzle Stars " << "v.:" << VERSION << " - Eric & Kota543 ]=--" <<endl;
	cout<< " -f - fullscreen mode"<<endl;
	cout<< " -h - this help"<<endl;
	cout<< " -w - windowed mode"<<endl;
}

void terminate_system()
{
	allegro_exit();
}


int main(int argc,char *argv[])
{
	int j,k,lm_current;
	char i;
	bool t2go,PlayBack=false, Recording=true, Jumpy=false;
	int Speed=20;
	string tmp;
	int preffered_mode = GFX_AUTODETECT;
	
	if (argc==2) {
		tmp = argv[1];
		if(tmp == "-h") {
			help_message();
			terminate_system();
			return 0;
		}
		if(tmp == "-f") {
			preffered_mode = GFX_AUTODETECT;
		}
		if(tmp == "-w") {
			preffered_mode = GFX_AUTODETECT_WINDOWED;
		}
	}
	
	init_message();
	set_pref_vidmode(preffered_mode);
  
	DATAFILE *DF=init();

	BITMAP *to_screen=vidmode(SCRX,SCRY);
	shade_216(9999);

	WrTextData(u_Front,DF,false,to_screen);

	t2go=0; lm_current=0;

//	if (argc>1) JoDaMain(argv[1],DF);


	MenuList mlMain, mlPuzzles, mlMusic, mlOptions/*, mlRes*/;

	MenuItem i1(&mlPuzzles,"Play"), i2("How To Play",-2), i3("Credits",1),
		i4("Playback",&PlayBack), i5("Quit",-1), 
		//i6("JoDa",3), 	Joda removed - still segfaults
		i7(&mlMusic,"Music Test"), i8(&mlOptions,"Options"),
		i9("Recording",&Recording), 
		/*i11("320 x 200",0), i12("640 x 480",0),*/ 	//Mode selection is not necessary
		/*i13("Jumpy mode",&Jumpy), */			//Program were freezing
		i14("Timer speed",&Speed,10,200), i21("No1",4), 
		i22("No 2",4), i23("No 3",4), i24("KoC overture",4);

/*	mlRes << i11 << i12;
	MenuItem i10("Resolution",&mlRes);*/

	mlMusic << i21 << i22 << i23 << i24;
	mlOptions << i9 << i7 << /*i10 << i13 << */i14;
	mlMain << i1 << i2 << i3 << i4 << i8 << /*i6 << */i5;

	for (j=0;j<(int)PuzMenu.size();j++)
	{
		MenuItem *i10=new MenuItem(PuzMenu[j].name,2);
		mlPuzzles << i10; // will we destruct these afterwards?
	}
/*	mlRes.index=1;*/
	MenuSet ms;
	ms.bmp=to_screen;
	ms.wordcol0  = COL_WHITE;
	ms.wordcol1  = COL_BLACK;
	ms.hilightcol= COL_CYAN;
	ms.linecol   = COL_WHITE;
	ms.min_x=40; ms.max_x=600;
	ms.min_y=40; ms.max_y=400;
	ms.Push(&mlMain);

//	smallfont = (FONT *)DF[u_smallfont].dat;
	while (!t2go)
	{
		clear_to_color(to_screen,9);
		ms.Draw();
		text_mode(-1);
		draw_sprite(to_screen,(BITMAP *)DF[u_logo].dat,104,SCREEN_H/40+40);
		draw_sprite(to_screen,(BITMAP *)DF[u_title].dat,210,SCREEN_H/40);
/*		textout_centre(to_screen,(FONT *)DF[u_bigfont].dat,"PUZZLE STARS",SCREEN_W/2,SCREEN_H/40,COL_WHITE);
		textout_centre(to_screen,(FONT *)DF[u_bigfont].dat,"Eric Love & Kota543 Software",SCREEN_W/2,SCREEN_H/40+25,COL_WHITE);*/
		blit(to_screen,screen,0,0,0,0,SCRX,SCRY);

		k=readkey();
#ifdef LINUX
		usleep(1);
#endif
		i=ms.OnKey(k);

		if (i==-2)
		{
			WrTextData(u_Howto1,DF,true,to_screen);  readkey();
			WrTextData(u_Howto2,DF,true,to_screen);  readkey();
			WrTextData(u_Howto3,DF,true,to_screen);  readkey();
			WrTextData(u_Howto4,DF,true,to_screen);  readkey();
			WrTextData(u_Howto5,DF,true,to_screen);  readkey();
			WrTextData(u_Howto6,DF,true,to_screen);  readkey();
		}
		if (i==-1) t2go=true;

		if (i==1)  { WrTextData(u_Credits1,DF,true,to_screen); readkey();  }

		if (i==2)
		{ 
			StageManager S;
			S.L=PuzMenu[mlPuzzles.index];
			S.D=DF; S.playback=PlayBack;
			S.recording=Recording;
			S.jumpy=Jumpy;
			S.set_screen_option(2);
			S.Init();
			set_timer_speed(Speed);
			//        orep << ms.active << " - Go {" << endl;
			S.Go();
			//        orep << "} Go - " << ms.active << endl;
			ReScr();
		}

		if (i==3) { JoDaMain(NULL,DF); ReScr(); }

		if (i==4) play_midi((MIDI*)DF[u_Music1+mlMusic.index].dat,true);

	}

	terminate_system();
	cout<<"Program terminated... OK"<<endl;
	
	return 0;
}
END_OF_MAIN();

void ReScr()
{
  vidmode(SCRX,SCRY);
  shade_216(9999);
} 
