#include "menu.h"
#include "basics.h"

  void NumChanger::OnUp()
  {  if (*p<max) (*p)++; }
  void NumChanger::OnDown()
  { if (*p>min) (*p)--; }

 // MenuItem class

  MenuItem::MenuItem()
  { list=NULL; kind=0; ret=0; }

  MenuItem::MenuItem(string n, int i)
  { list=NULL; name=n; ret=i; kind=1; }

  MenuItem::MenuItem(int k,string n, int i)
  { list=NULL; name=n; ret=i; kind=k; }

  MenuItem::MenuItem(string n,MenuList *l)
  { kind=5; list=l; name=n; }

  MenuItem::MenuItem(MenuList *l,string n)
  { kind=4; list=l; name=n; }

  MenuItem::MenuItem(string n, int *p,int min,int max)
  { kind=2; name=n;
    num=new NumChanger;
    num->p=p; num->min=min; num->max=max;
  }

  MenuItem::MenuItem(string n,bool *p)
  { name=n; b_ptr=p; kind=3; list=NULL; }

  string MenuItem::Rhs()
  {
    string s;
    if (kind==2) { s+=(char)48+*(num->p)/10; s+=(char)48+*(num->p)%10; }
    if (kind==3) s=(*b_ptr ? "On" : "Off" );
    if (kind==4) s=" ";
    if (kind==5) s=list->a[list->index]->name;
    return s;
  }

// MenuList class

  MenuList::MenuList()
  {
    size=0;
    index=0;
  }

  void MenuList::Add(MenuItem *m)
  {
    int w=30+text_length(font,m->name.c_str());
    if (!size)
    {
      m->y=5;
      width=w;
    }
    else
    {
      if (width<w) width=w;
      m->y=a[size-1]->y + 13;
    }
    int l=text_length(font,m->Rhs().c_str());
    if (l) l+=10+width;
    else l=width;
    if (!size || length<l)
      length=l;
    height=m->y+5; //  height of bottom
    a.push_back(m);
    size++;
  }
  
  void MenuList::Add(MenuItem &m)
  { Add(&m); }

  MenuList& MenuList::operator<< (MenuItem &m)
  { Add(m); return *this; }
  MenuList& MenuList::operator<< (MenuItem *m)
  { Add(m); return *this; }

  void MenuList::OnUp()
  {  if (index>0) index--;  }

  void MenuList::OnDown()
  { if (index<size-1) index++; }


// MenuSet class

  void MenuSet::Draw()
  {
//    orep << "Draw " << active Then flush;
    if (active<0) exit(1);
    int j,k;
    for (j=0; j<(int)a.size(); j++)
    {
      MenuList *l=a[j];
      MenuItem *m;

      vline(bmp,l->x, l->oy+l->a[0]->y, l->oy+l->a[l->size-1]->y,linecol);
      for (k=0; k<l->size; k++)
      {
        m=l->a[k];
        hline(bmp,l->x, l->oy+m->y, l->x+10, linecol);
        text_mode(l->index==k && active==j ? hilightcol : -1);
        textout(bmp,font,m->name.c_str(), l->x+15, l->oy+m->y-4, l->index==k ? wordcol1 : wordcol0);
        if (j==(int)a.size()-1)
        { 
          string s=m->Rhs();
          if (!s.empty())
          {
            hline(bmp,l->x+20+text_length(font,m->name.c_str()), l->oy+m->y, l->x+l->width+0, linecol);
            text_mode(l->index==k && (active==j+1 || m->kind==3) ? hilightcol : -1);
            textout(bmp,font,s.c_str(), l->x+5+l->width, l->oy+m->y-4, l->index==k ? wordcol1 : wordcol0);
          }
        }
      }
      if (j<(int)a.size()-1)
      {
        m=l->a[l->index];
        hline(bmp,l->x+20+text_length(font,m->name.c_str()), l->oy+m->y, l->x+l->width, linecol);
      }
    }
//    orep << endl;
  }

  void MenuSet::Pop()
  {
    int j,xs;
    if (active==(int)a.size()-1) a.pop_back();
    active--;
    xs=min_x-a[active]->x;
    if (xs>0)
      for (j=0;j<=active;j++)
        a[j]->x+=xs;
  }

  void MenuSet::Push(MenuList *l)
  {
    int xs,xs1,xs2,j;
    a.push_back(l);
    active++;
    if (active)
    {
      l->x=lc->x+lc->width;
      xs=l->length+l->x-max_x;
      if (xs>0)
        for (j=0;j<=active;j++)
          a[j]->x-=xs;
      l->oy=lc->oy+ic->y-l->height/2;
      xs=l->height/2-l->a[l->index]->y;
      xs1=min_y-l->oy;
      xs2=l->oy+l->height-max_y;
      if (xs1+xs2<=0)
      {
        if (xs1>0)
          l->oy+=xs1;
        if (xs2>0)
          l->oy-=xs2;
      }
      else {}
//        if (xs>0)
    }
    else
    {
      lc=l; ic=l->a[l->index];
      l->x=min_x;
      l->oy=(min_y+max_y-l->height)/2;
    }
  }

  MenuSet::MenuSet()
  {
    nc=NULL;
    active=-1;
  }

  int MenuSet::OnKey(int c)
  {
    int ch=c>>8;

    if (ch==KEY_LEFT)
    {
      if (active) Pop();
    }
    if (ch==KEY_RIGHT)
    {
      if (nc) return 0;
      if (ic->kind==4 || ic->kind==5) Push(ic->list);
      if (ic->kind==2) active++;
    }
    if (ch==KEY_UP)
    {
      if (nc) nc->OnUp();
      else a[active]->OnUp();
    }
    if (ch==KEY_DOWN)
    {
      if (nc) nc->OnDown();
      else a[active]->OnDown();
    }
    if (ch==KEY_ENTER)
    {
      if (nc) Pop();
      else if (ic->kind==2) active++;
      if (ic->kind==1) return ic->ret;
      if (ic->kind==3) *(ic->b_ptr)=!*(ic->b_ptr);
      if (ic->kind==4 || ic->kind==5) Push(ic->list);
    }
    if (ch==KEY_ESC)
    {
      if (active) Pop();
      else if (ic->ret==-1) return -1;
      else lc->index=lc->size-1;
    }
    if (ch==KEY_F1) return -2;

    nc=NULL;
    if (active<(int)a.size()) lc=a[active];
    else if (ic->kind==2) nc=ic->num;
    ic=lc->a[lc->index];
    return 0;
  }
