#include <string>
#include <vector>
using namespace std;
#include <allegro.h>

struct NumChanger;
struct MenuItem;
struct MenuList;

struct NumChanger
{
  int *p,min,max;

  void OnUp();
  void OnDown();
};

struct MenuItem
{
  int kind; // 1=node, 2=number, 3=bool, 4=submenu, 5=list of choices
  MenuList *list;
  string name;
  int y,ret;
  bool *b_ptr;
  NumChanger *num;

  MenuItem();
  MenuItem(string n, int i);
  MenuItem(int k,string n, int i);
  MenuItem(string n,MenuList *l);
  MenuItem(MenuList *l,string n);
  MenuItem(string n, int *p,int min,int max);
  MenuItem(string n,bool *p);

  string Rhs();
};

struct MenuList
{
  vector <MenuItem*> a;
  int size,oy,x,index,width,length,height;

  MenuList();

  void Add(MenuItem *m);
  void Add(MenuItem &m);

  MenuList& operator<< (MenuItem &m);
  MenuList& operator<< (MenuItem *m);

  void OnUp();
  void OnDown();
};

struct MenuSet
{
  vector <MenuList*> a;
  int active;
  MenuList *lc; // current MenuList
  MenuItem *ic; // current MenuItem
  NumChanger *nc; // current NumChanger (if there is one)
  int linecol, wordcol0, wordcol1, hilightcol;
  int min_x,max_x,min_y,max_y;
  BITMAP *bmp;

  MenuSet();

  void Draw();

  void Pop();
  void Push(MenuList *l);

  int OnKey(int c);
};
 
