#include <allegro.h>
#include "puz.h"
#include "music.h"

MIDI *midi_data(DATAFILE *D,int i)
{
  if (i<0 || i>=u_COUNT) return NULL;
  if (D[i].type!=DAT_MIDI) return NULL;
  return (MIDI*) D[i].dat;
}

void music_manager::Init(DATAFILE *DF,char num,bool b)
{
  notrump=midi_data(DF,u_Music1+num-1);
  trump=midi_data  (DF,u_Musit1+num-1);
  loop=b;
  request=0; 
  silent_time=trumpet_time=0;
}

void music_manager::Stop()
{  stop_midi(); }

music_manager::~music_manager()
{ Stop(); }

void music_manager::RequestTrumpet()
{ request=1; }

void music_manager::RequestSilence()
{ request=3; }

void music_manager::Play()
{
  play_midi(notrump,loop);
  last_pos=1;beat_len_ctr=0;beat_len=99;
}

void music_manager::Regular()
{
  if (silent_time)
  { 
    silent_time--;
    if (!silent_time) Play();
    return;
  }
  if (trumpet_time && !request)
  {
    trumpet_time--;
    if (!trumpet_time)
      request=2;
  }
  beat_len_ctr++;
  if (last_pos!=midi_pos)
  {
    last_pos=midi_pos;
    if (beat_len==99) beat_len=beat_len_ctr;
    if (beat_len>beat_len_ctr) beat_len--;
    if (beat_len<beat_len_ctr-1) beat_len++;
    beat_len_ctr=0;
  }
  else if (beat_len_ctr==beat_len-1)
  {
    if (request==1)
    {
      play_midi(trump,loop);
      midi_seek(last_pos+1); //length?
      trumpet_time=70;
    }
    else if (request==2)
    {
      play_midi(notrump,loop);
      midi_seek(last_pos+1); //length?
    }
    else if (request==3)
    { 
      Stop(); 
      silent_time=150;
    }
    request=0;
  }
}
