#include <cmath>
#include "str.h"
#include "o_1.h"

// ------------------------------ Fixed shape Set Piece -----------------
#define CurrentType Setpiece

/*
Current values for what are:
4,5: curve; 6: decoration
*/

int Setp_triangle1[]={-20,-20, -10,0, -20,20};
int Setp_triangle2[]={-20,-20, 0,-10, -10,0};
int Setp_triangle3[]={-20,-20, 20,-20, 0,-10};
int Setp_triangle4[]={0,-10,   20,-20, 10,0};
int Setp_triangle5[]={10,0,    20,-20, 20,20};


  Setpiece::Setpiece()
  {
    kind=xk_Setpiece;
    what=0;sx=200;sy=50;
  }

  LoadI
  {
    shape *s1,*s2,*s3;
    if (f(20)) f >> what;

    switch(what)
    {
    case 1: sh_eq(new_rectangle(100,15)); break;
    case 2: sh_eq(new_circl(10)); break;
    case 3: sh_eq(new_rectangle(2,60)); break;
    case 4:
      s1=make_polygon(3,Setp_triangle1);
      s2=make_polygon(3,Setp_triangle2);
      s3=make_polygon(3,Setp_triangle3);
      sh_eq(new_twoshapes(new_twoshapes(s1,s2),s3));
      break;
    case 5:
      s1=make_polygon(3,Setp_triangle3);
      s2=make_polygon(3,Setp_triangle4);
      s3=make_polygon(3,Setp_triangle5);
      sh_eq(new_twoshapes(new_twoshapes(s1,s2),s3));
      break;
    }
  }

  SaveI
  {   if (what) f << 20 << what; }

  SeeI
  {
    if (visible(v,sx,sy)) v->add(4,xk_Setpiece,vpx,vpy,what);
  }

//  DeleteI

  EditI
  {
    w->WrStr("Selected:");
    w->WrStr(" Fixed Set Piece");
    w->Ln();
    WrPos(w);
    
  }

#undef CurrentType
//------------------------------ Door -------------------------
#define CurrentType Door

  Door::Door()
  {
    kind=xk_Door;
    way=colour=1;
  }

  SeeI
  {
    if (visible(v,20,20)) v->add(5,xk_Door,vpx,vpy,colour-1,way-1);
  }

  ReshapeI
  {
    if (way==1) way_thru=-PI/2;
    if (way==2) way_thru=PI/2;
    if (way==3) way_thru=PI;
    if (way==4) way_thru=0;
    if (way>2) sh_eq(new_rectangle(5,20));
    else sh_eq(new_rectangle(20,5));
  }

  EditI
  {
    w->WrStr("Selected: Door");
    w->Ln();
    w->WrStr("Colour:");
    w->GiveChoices(colour_choices,4,&colour,1);
    w->Ln();
    w->WrStr("Opens from:");
    w->GiveChoices(way_choices,4,&way,2);
    w->Ln();
    WrPos(w);
  }

  LoadI
  {
    if (f(20)) f >> colour;
    if (f(21)) f >> way;
  }

//  DeleteI

  SaveI
  {
    if (colour!=1) f << 20 << colour;
    if (way!=1) f << 21 << way;
  }

#undef CurrentType
//----------------------- Rectangular set piece ----------------------
#define CurrentType Setp2

  ReshapeI
  {  sh_eq(new_rectangle(width,height));  }

  Setp2::Setp2()
  {
    kind=xk_Setp2;
    width=50; height=25;
    pattern=0;
    colour1=Default_Colour;
    reshape();
  }

//  DeleteI

  SeeI
  {
    if (visible(v,width,height))
      v->add(6,xk_Setp2,vpx,vpy,width,height,colour1);
  }

  EditI
  {
    w->WrStr("Selected:");
    w->WrStr("  Rectangle");
    w->Ln();
    w->NumEdit(" Width:  ",&width,s_int);
    w->NumEdit(" Height: ",&height,s_int);
    w->NumEdit("Colour:   ",&colour1,s_colour);
    w->Ln();
    WrPos(w);
  }

  LoadI
  {
    if (f(20)) f >> width;
    if (f(21)) f >> height;
    if (f(22)) f >> colour1;
  }

  SaveI
  {  f << 20 << width << 21 << height << 22 << colour1; }

  void Setp2::key_Q()
  {
    if (keySHIFT) height--;
    else height-=5;
    if (height<1) height=1;
  }

  void Setp2::key_A()
  {
    if (keySHIFT) height++;
    else height+=5;
    if (height>Setp2_max_height) height=Setp2_max_height;
  }

  void Setp2::key_O()
  {
    if (keySHIFT) width--;
    else width-=5;
    if (width<1) width=1;
  }

  void Setp2::key_P()
  {
    if (keySHIFT) width++;
    else width+=5;
    if (width>Setp2_max_width) width=Setp2_max_width;
  }

#undef CurrentType
// ----------------------------- Iceblock ----------------------
#define CurrentType Iceblock

int Iceblock_poly1[]={-100,-50,100,-150,300,-150,300,-50};


  Iceblock::Iceblock()
  {
    kind=xk_Iceblock;
    sh_eq(new_twoshapes(new_rectangle(300,50),make_polygon(4,Iceblock_poly1)));
  }

//  DeleteI

  EditI
  {
    w->WrStr("Iceblock");
    w->Ln();
    WrPos(w);
  }

  SeeI
  { if (visible(v,300,150)) v->add(3,xk_Iceblock,vpx,vpy);  }

#undef CurrentType
// ---------------------------- Seismos---------------------------
#define CurrentType Seismos

int Seismos_poly1[]={0,0, 0,-400, 50,0};
int Seismos_poly2[]={-650,0, -600,-400, -600,50};
int Seismos_poly3[]={-400,0, 0,0, -600,40};

  Seismos::Seismos()
  {
    kind=xk_Seismos;
    sh_eq (new_twoshapes(
      new_twoshapes (make_polygon(3,Seismos_poly1),make_polygon(3,Seismos_poly2)),
      new_twoshapes (make_polygon(3,Seismos_poly3),new_circl(200)))
    );
    shakes=NULL;
  }

  LoadI
  {  cx=px; cy=py;  }

//  DeleteI

  EditI
  {
    w->WrStr("Selected: Seismos");
    w->Ln();
    WrPos(w);
  }

  OnebodyI
  {
    Seismos_shake *s1,*s2;
    if (random()%40==1)
    {
      s1=new Seismos_shake;
      s1->prev=NULL;
      if (shakes) shakes->prev=s1;
      s1->next=shakes;
      shakes=s1;
      s1->w=sq(Rnd()*0.8+0.5);
      s1->t=sq(Rnd()*7+1);
      s1->ax=12*Rnd()-6;
      s1->ay=12*Rnd()-6;
    }
    vx=0.6*(cx-px); vy=0.6*(cy-py);
    for (s1=shakes;s1;s1=s2)
    {
      s2=s1->next;
      vx+=s1->ax*sin(s1->t);
      vy+=s1->ay*sin(s1->t);
      s1->t-=s1->w;
      if (s1->t<0)
      {
        if (s2) s2->prev=s1->prev;
        if (s1->prev) s1->prev->next=s2; // crashes here
        if (s1==shakes) shakes=s2;
        delete s1;
      }
    }
  }

  SeeI
  {
    visible(v,150,15);
    v->add(3,xk_Seismos,vpx,vpy);
  }

#undef CurrentType 
