
#include <fstream>
#include "basics.h"
#include "shape.h"
#include "view.h"
#include "object.h"


lone_Object lorac[max_xkinds];

void set_proc(int i,char flags,int xk_parent)
{
  lorac[i].xk_parent=xk_parent;
  lorac[i].flags=flags;
}

  Object::Object()
  {
    prev=next=NULL;
    net_r=net_d=NULL;
    collected=0;
    sh=NULL;
    vx=vy=vt=0;
    px=py=0;
    togo=tlu=0;
  }

  void Object::s_load(loader &f)
  {
    int d;
    if (f(1)) f >> px >> py;
    if (f(2)) f >> vx >> vy;
    if (f(3)) f >> togo;
    if (f(4)) f >> d;
  }

  void Object::s_save(saver &f)
  {
     f << kind;
    if (px || py)       f << 1 << px << py;
    if (Abs(vx)>0.1 || Abs(vy)>0.1) f << 2 << vx << vy;
    if (togo)           f << 3 << togo;
  }

  Object::~Object() {
    if (sh) delete sh;
  }

  void Object::onebody(c_reporter &cr) {}
  void Object::see(view *v) {}
  void Object::move() {}
  void Object::edit(Window *w) {}
  void Object::key_Q() {}
  void Object::key_A() {}
  void Object::deport() {}
  void Object::reshape() {}
  void Object::key_O() {}
  void Object::key_P() {}
  void Object::save(saver &f) {}
  void Object::load(loader &f) {}
//  void Object::deleet() { delete this; }

  void Object::WrPos(Window *w)
  {
//    w->WrStr("Position");
//    w->NumEdit(" X: ",&px,s_int);
//    w->NumEdit(" Y: ",&py,s_int);
  }

  void Object::speed_limit()
  {
     orep<< "This Object ("<<kind << ") broke the speed limit. vx=" << vx << ", vy=" << vy << ", px=" << px << ", py=" << py << endl;
     exit(0);
  }

#define IF if (0) orep

  void Object::calibrate()
  {
    unsigned int avx,avy;
    int d,ctr=0;

IF << "[" << Time;
    svx=(vx<0);
    avx=fl2i(Abs(vx));
    if (avx>1000) speed_limit();
    if (avx)
    {
      tnsx=0x8000/avx;
      tbsx=0x10000/avx;
IF << " (" << avx Then tnsx << ") ";
      if (!tbsx) { orep << "Calibration error, avx=" << avx << "\n"; exit(0); }
      while (tlu>tnsx) { tnsx+=tbsx; ctr++; }
      d=(0x10000-tnsx+tbsx-1)/tbsx;
      if (svx) qx=px-d; else qx=px+d;
    }
    else
    {
      tnsx=0x10000;
      tbsx=0x33333;
      qx=px;
    }
IF << Time Then avx Then tnsx Then tbsx Then ctr;

    svy=(vy<0);
    avy=fl2i(Abs(vy));
    if (avy>1000) speed_limit();
    if (avy)
    {
      tnsy=0x8000/avy;
      tbsy=0x10000/avy;
      while (tlu>tnsy) tnsy+=tbsy;
      if (!tbsy) { orep << "Calibration error, avy=" << avy << "\n"; exit(0); }
      d=(0x10000-tnsy+tbsy-1)/tbsy;
      if (svy) qy=py-d; else qy=py+d;
    }
    else
    {
      tnsy=0x10000;
      tbsy=0x33333;
      qy=py;
    }
IF << "]" << endl;
  }

  void Object::move(int mx,int my)
  {  px+=mx; py+=my;  }

  void Object::locate(int x,int y)
  {  px=x;py=y; }

  void Object::locate_with_me(Object *x)
  {  x->px=px; x->py=py; x->vx=vx; x->vy=vy; }

  void Object::sh_eq(shape *s)
  {
    if (sh) delete sh;
    sh=s;
  }

  void Object::vreset()
  {   vx=ovx;vy=ovy; }

  void Object::up_to_date(int t)
  {
    tlu=t;
    svx=(vx<0);
    svy=(vy<0);
    while(t>tnsx)
    {
      tnsx+=tbsx;
      if (svx) px--;
      else px++;
    }
    while(t>tnsy)
    {
      tnsy+=tbsy;
      if (svy) py--;
      else py++;
    }
  }

char Object::visible(view *v,int sx,int sy)
{
  vpx=px-v->px;
  vpy=py-v->py;
  if (abs(vpx)>sx+v->sx) return 0;
  if (abs(vpy)>sy+v->sy) return 0;
  return 1;
}

char Object::flags(int a)
{
  if (kind<max_xkinds || kind>=0)
  {
    int f=lorac[kind].flags;
    if (f) return f&a;
  }
  orep << "No Object kind number " << kind << endl; exit(0);
}

char Object::saveable()
{ return flags(1); }
