#ifndef _OBJECT_H_
#define _OBJECT_H_

#define max_xkinds 170

#include <cstdio>
#include "shape.h"
#include "fio3.h"
#include "c_types.h"

struct lone_Object
{
  int xk_parent;
  char flags;
};

extern lone_Object lorac[max_xkinds];

// Declarations of commonly used functions

#define LoadD    void load(loader &f)
#define SaveD    void save(saver &f)
#define SLD      SaveD; LoadD
#define SeeD     void see(view *v)
#define EditD    void edit(Window *w)
#define OnebodyD void onebody(c_reporter &cr)
#define MoveD    void move()
#define ReshapeD void reshape();

// To be used where the functions are implemented

#define SaveI   void CurrentType::save(saver &f)
#define LoadI   void CurrentType::load(loader &f)
#define OnebodyI void CurrentType::onebody(c_reporter &cr)
#define MoveI   void CurrentType::move()
#define EditI   void CurrentType::edit(Window *w)
#define SeeI    void CurrentType::see(view *v)
#define ReshapeI void CurrentType::reshape()

class net_unit;
class view;
struct Window;

struct Object{
  int kind;
  Object *next,*prev;

  shape *sh;
  int px,py,qx,qy,vpx,vpy;
  char svx,svy;
  float vx,vy,m,vt,ovx,ovy;

  char collected;
  net_unit *net_r,*net_d;
  int tnsx,tnsy,tbsx,tbsy,tlu,n_clsns;
  int togo;

  Object();
  void s_load(loader &f);
  void s_save(saver &f);
  virtual ~Object();

  virtual OnebodyD;
  virtual SeeD;
  virtual MoveD;
  virtual EditD;
  virtual void key_Q();
  virtual void key_A();
  virtual ReshapeD;
  virtual void deport();
  virtual void key_O();
  virtual void key_P();
  virtual SaveD;
  virtual LoadD;
//  virtual DeleteD;

  void WrPos(Window *w);

  void speed_limit();
  void calibrate();
  void move(int mx,int my);
  void locate(int x,int y);
  void locate_with_me(Object *x);
  void sh_eq(shape *s);
  void vreset();
  void up_to_date(int t);
  char visible(view *v,int sx,int sy);

  void de_net();
  char flags(int);
  char saveable();
} ;


Object *new_x(int k);  // Must be defined outside engine

#define OB(x) (Object*)x

#endif 
