#ifndef _STAGE_H_
#define _STAGE_H_

#include <vector>
using namespace std;
#include "c_solve.h"
#include "msg.h"

struct Stage_header{  // will be removed
  char music_number;
  char music_loop;
  char edited_by;
  char fill;
  short length;
  short any_more;
};


class Stage{

  Object *waiting_list, // Objects waiting to enter
         *exit_list,    // Objects waiting to exit
         *request_list; // unused

  vector <MsgQueue*> subscribers;

  void en_waiting_list(Object *x);
  c_reporter Rep;
  blatrix WorkingMB;

  friend class c_reporter;

public:
  vector <Object*> check_list;

  void remove_Object(Object *x); // I was hoping to keep them private

  Object *list; // The list of active Objects (doubly linked)

  int total_clsns;

  Stage_header head;  // soon to be removed
  string header;

  Stage();
  ~Stage();

  void subscribe(MsgQueue *mq);
  void broadcast(message &m);

  void add_Object(Object *x); // Adds x to the Stage, putting all the approprate net units in the net

  void remove_list(Object *x,bool r);

  void delete_list(); //  deletes the whole Stage

  int length(Object *x); // number of saveable Objects on a given list

  void load(char*); // puts Objects stored in a file into the Stage
  void load(string);

  void save(char*); // stores Object data into a file
  void save(string);

  void do_intelg_list(); // executes each Object's move function, where it chooses how to move

  void Physics_I(); // Executes each Object's xk_onebody function, where it may change speed.

  void Physics_II();
/*
 Iterates though the net. Any pair with checks bit 0 set is tested to see if they are touching. If any pair has checks bit 1 set, its proc function is called. The report returned (cr1) isn't used, although I suspect it should be. Any pair with checks bits 2 or 3 set is tested for collisions (bit 2 for external collisions, bit 3 for internal collsions) using check_collsion. If a collision is imminent, the collision notification returned is added to a heap. Having gone through the entire net and built up the heap, any Objects which will have to be removed have all the notifications in which they are involved removed from the heap. Then each element of the heap starting from the top is dealt with using the deal_with function in xkinds2.c which returns a collision report. The Objects listed in the c variable of ther report have had their speed changed, so any notifications in the heap involving that Object are removed, the relevant checks performed again, and any new entries added to the heap. Any Objects in the n variable of the report are put on the waiting list to be added later
*/

  void Physics_III();
/*
All Objects finish moving according to their velocities and how for they had been moved during the collision calulations in Physics_II. Any Object with a non-zero togo number has togo decremented by 1. If this brings it down to 0, the Object is removed from the stage and put on the exit list. Any Objects on the waiting list are added to the stage. Adding and removing Objects to the stage involves adding or removing elements from the net.
*/

  void do_draw_list(view *v); // draws the Stage into a view, using each Object's see function

  // void describe() : writes data about each Object in the Stage (Lost somehow)

};

#endif 
