#include <cstdio>
#include <string>
#include <cstdlib>
#include <ctime>
#include "puz.h"
#include "o_1.h"
#include "xkinds3.h"
#include "high.h"
#include "kbt.h"

#include "shape.h"

#define COLOR_DEPTH	8

vector <string_pair> PuzMenu;


DATAFILE *init()
{
  int j,d_id,m_id,n_samples;

//  char pn[20],*p;
  SAMPLE *u;

  orep.setf(ios::fixed);
  orep.precision(2);

// Allegro stuff
  allegro_init();
  install_keyboard(); 
  install_timer();

// Datafile
  set_color_depth(COLOR_DEPTH);
  set_color_conversion(COLORCONV_NONE);
  DATAFILE *DF=load_datafile("puz.dat");
  j=n_samples=0;
  for (j=0;DF[j].type!=DAT_END;j++)
  {

    if (DF[j].type==DAT_SAMPLE)
    {
      n_samples++;

      if (n_samples==sfx_SuperButton)
//        if ((u=load_wav("/Windows/Media/Utopia Windows Start.wav")))
 //       {  DF[j].dat=u; Sfx_frequencies[n_samples]=10; }
//        else 
	DF[j].dat=DF[j-n_samples+sfx_Teleport].dat;

      if (n_samples==sfx_ChainCut || n_samples==sfx_StarSquash)
        DF[j].dat=DF[j-n_samples+sfx_LaserSquash].dat;
    }
  }


// Menu
  string_pair ss;

  ifstream f1("levels.txt");
  istringstream lm((char *)DF[u_Levels].dat);

  istream& in=lm;

  while (1)
  {
    getline(in,ss.prefix,'.');
    getline(in,ss.name,'\n');
    j=ss.name.length()-1;
    if (ss.name[j] < ' ')
      ss.name[j]=0;
    if (!in) break;
    PuzMenu.push_back(ss);
  }


// Local init routines
  initialise_xkinds1();
  initialise_xkind_pairs();
  initialise_kbt();

// GUI stuff
  text_mode(c3(444));
  gui_fg_color=1;
  gui_bg_color=105;
  gui_mg_color=87;
  install_mouse();

// Sound
  m_id=MIDI_AUTODETECT;
  d_id=DIGI_AUTODETECT;
//  reserve_voices(4,4);
  SoundOn=!install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT,NULL);

  srandom(time(NULL));

  return DF;
}
