#include <allegro.h>

#include "basics.h"
#include "xkinds3.h"
#include "o_1.h"

using namespace std;

void initialise_xkinds1()
{
  for (int j=0;j<max_xkinds;j++) lorac[j].flags=0;

  set_proc(xk_Object  ,8,0);
  set_proc(xk_Setpiece,3,xk_Object);
  set_proc(xk_Star    ,3,xk_Object);
  set_proc(xk_Door    ,3,xk_Setpiece);
  set_proc(xk_Gettable,3,xk_Object);
  set_proc(xk_Quay    ,3,xk_Gettable);
  set_proc(xk_Player  ,1,xk_Object);
  set_proc(xk_Home    ,3,xk_Object);
  set_proc(xk_Platform,1,xk_Setpiece);
  set_proc(xk_Lever   ,3,xk_Object);
  set_proc(xk_Teleport,3,xk_Object);
  set_proc(xk_Backg   ,1,xk_Object);  
  set_proc(xk_Pushme  ,3,xk_Object);  
  set_proc(xk_Cutter  ,3,xk_Gettable);
  set_proc(xk_Chain   ,3,xk_Object);
  set_proc(xk_Setp2   ,3,xk_Setpiece);
  set_proc(xk_Spikes  ,3,xk_Object);
  set_proc(xk_Magneton,8,xk_Object);
  set_proc(xk_Magnet  ,7,xk_Device);
  set_proc(xk_Zapper  ,7,xk_Device);
  set_proc(xk_Door2   ,7,xk_Setpiece);
  set_proc(xk_Ctrlbox ,3,xk_Object);
  set_proc(xk_Phonon  ,8,xk_Object);
  set_proc(xk_Gong    ,3,xk_Object);
  set_proc(xk_Mallet  ,3,xk_Gettable);
  set_proc(xk_Trumpet ,3,xk_Gettable);
  set_proc(xk_Zed     ,8,xk_Object);
  set_proc(xk_Heavy   ,3,xk_Object);
  set_proc(xk_Laser   ,7,xk_Device);
  set_proc(xk_Mirror  ,3,xk_Object);
  set_proc(xk_Photon  ,8,xk_Object);
  set_proc(xk_Bat     ,3,xk_Gettable);
  set_proc(xk_Seismos ,3,xk_Setpiece);
  set_proc(xk_Iceblock,3,xk_Object);
  set_proc(xk_Ferris  ,3,xk_Object);
  set_proc(xk_Device  ,7,xk_Object);
}
/* Here some flags are set for each object kind and the parent kind is specified. Bit 0 of the flag is whether it is saved when the whole stage is saved. Bit 1 is whether it can be selected in JoDa. Bit 2 indicates whether it is a device. Bit 3 does nothing.
*/

Object *call_new(int k)
{
  switch(k)
  {
  case xk_Object  :return new Object;
  case xk_Setpiece:return new Setpiece;
  case xk_Star    :return new Star;
  case xk_Door    :return new Door;
  case xk_Gettable:return new Gettable;
  case xk_Quay    :return new Quay;
  case xk_Player  :return new Player;
  case xk_Home    :return new Home;
  case xk_Platform:return new Platform;
  case xk_Lever   :return new Lever;
  case xk_Teleport:return new Teleport;
  case xk_Backg   :return new Backg;
  case xk_Pushme  :return new Pushme;
  case xk_Cutter  :return new Gettable;
  case xk_Chain   :return new Chain;
  case xk_Setp2   :return new Setp2;
  case xk_Spikes  :return new Spikes;
  case xk_Magneton:return new Object;
  case xk_Magnet  :return new Magnet;
  case xk_Zapper  :return new Zapper;
  case xk_Door2   :return new Door2;
  case xk_Ctrlbox :return new Ctrlbox;
  case xk_Phonon  :return new Object;
  case xk_Gong    :return new Gong;
  case xk_Mallet  :return new Gettable;
  case xk_Trumpet :return new Gettable;
  case xk_Zed     :return new Zed;
  case xk_Heavy   :return new Heavy;
  case xk_Laser   :return new Laser;
  case xk_Mirror  :return new Mirror;
  case xk_Photon  :return new Photon;
  case xk_Bat     :return new Gettable;
  case xk_Seismos :return new Seismos;
  case xk_Iceblock:return new Iceblock;
  case xk_Ferris  :return new Ferris;
  }
  orep << "Call-new failed, k=" << k; exit(0);
}

Object *new_x(int k)
{
  Object* r=call_new(k);
  r->kind=k;
  if (k==xk_Magneton || k==xk_Phonon) r->sh_eq(new_point());
  return r;
}

char is_device(Object *o)
{ return o->flags(4); }

char selectable(Object *o)
{ return o->flags(2); }
