#ifndef _XKINDS3_H_
#define _XKINDS3_H_

enum { xk_Object, xk_Setpiece=3, xk_Star, xk_Door, xk_Gettable, xk_Quay, xk_Player, xk_Home, xk_Platform, xk_Lever, xk_Teleport, xk_Possession, xk_Backg, xk_Pushme, xk_Viewreqest, xk_Cutter, xk_Chain, xk_Setp2, xk_Spikes, xk_Magneton, xk_Magnet, xk_Zapper, xk_Door2, xk_Ctrlbox, xk_Phonon, xk_Gong, xk_Mallet, xk_Trumpet, xk_Zed, xk_Heavy, xk_Laser, xk_Mirror, xk_Photon, xk_Bat, xk_Seismos=37, xk_Iceblock, xk_Ferris, xk_Device };

/*
The different objects in the game are instances of different classes, all extended from the Object class. All the classes are listed here, prefixed with "xk_" to associate them with a number (the Object's "kind" variable). Each of these classes...
*/
struct Object;

void set_proc(int i,char flags,int xk_parent);

char is_device(Object*);
char selectable(Object*);

void initialise_xkind_pairs();
void initialise_xkinds1();

//Sound effects

extern int Sfx_frequencies[];

#define sfx_MirrorSmash  1
#define sfx_Gong         2
#define sfx_DeviceClick  3
#define sfx_DoorOpen     4
#define sfx_Clap         5
#define sfx_Buzz         6
#define sfx_Bell         7
#define sfx_Teleport     8
#define sfx_Zap          9
#define sfx_LaserSquash 10
#define sfx_ChainCut    11
#define sfx_StarSquash  12
#define sfx_StarSpike   13
#define sfx_GetItem     14
#define sfx_SuperButton 15
#define sfx_Trumpet     16
#endif 
